#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "mmil.h"

/* Functions */

word getPw(FILE *stream)

{
  word dummy;

  if((dummy = fgetc(stream)) == EOF) {
    if(feof(stream)) printf("End - of - file\n");
    else if(ferror(stream)) printf("Error! %d \n",errno);
    exit(1);
  }
  else {
    dummy += getc(stream)*256;
    return(dummy);}
}

char *getPString(stream,size)

FILE *stream;
word size;
{
  int length, i;
  char *string, dummy;

  if ((length=fgetc(stream))==EOF) {
    if (feof(stream)) printf("End - of - file\n");
    else if (ferror(stream)) printf("Error! %d\n",errno);
    exit(1);
  }
  string =(char *)malloc(sizeof(char)*(length+1));
  *string = 0;
  i = 0;
  while (++i<=length)
    {
      dummy = fgetc(stream);
      strncat(string, &dummy,1);
    } /* endwhile */
  dummy = 0;
  strncat(string, &dummy, 1);
  while (++i<=size)
    { fgetc(stream);}
  /* endwhile */
  return(string);
}

/* mmil related functions */

void freadmmil(char *path, struct TMMIL *mmil)

{
  FILE *f;

  f = fopen(path, "rb");
  if (f==NULL) {
    printf("fopen reported error\n");
    exit(1);
  }
  mmil->tag = getPString(f,3);
  if (strcmp(mmil->tag,"MM"))
    { printf("not a MMIL.DAT\n"); exit(1); }
  mmil->majorver = getPw(f);
  mmil->minorver = getPw(f);
  mmil->MsgNumber = getPw(f);
  mmil->fromName = getPString(f,37);
  mmil->Zone = getPw(f);
  mmil->Net = getPw(f);
  mmil->Node = getPw(f);
  mmil->Point = getPw(f);
  mmil->Subject = getPString(f,73);
  mmil->Level = getPw(f);
  mmil->Key = getPString(f,27);
  mmil->define = getPString(f,256);
  mmil->cmline = getPString(f,256);
  fclose(f);
}

void deletemmill(struct TMMIL *mmil)
{
  free(mmil->tag);
  free(mmil->fromName);
  free(mmil->Subject);
  free(mmil->Key);
  free(mmil->define);
  free(mmil->cmline);
  free(mmil);
}
